<app-main-drawer [title]="'Configuration'">
    <div class="loading-bloc" *ngIf="loading">
        <img src="../../../assets/loading.gif" alt="loader" height="130px" width="120px" />
    </div>

    <div class="d-flex action-btn" style="justify-content: end;gap:20px;">

        <button *ngIf="GlobalAppService.userHasRole(AuthData.currentUser.Role, [RoleList.SuperAdminRoleName])"
            class="noShadow" [disabled]="loading || !currentAgency || !currentAgency?.ID" mat-mini-fab color="primary"
            matTooltip="ajouter une nouvelle agence" (click)="onAddAgencies()">
            <mat-icon fontSet="material-symbols-rounded">add_business</mat-icon>
        </button>

        <button class="noShadow" mat-mini-fab color="primary" (click)="saveAgencies()" matTooltip="sauvegarder"
            [disabled]="loading">
            <mat-icon fontSet="material-symbols-rounded">save</mat-icon>
        </button>

    </div>
    <mat-tab-group>
        <mat-tab label="informations générales">
            <div class="bloc-content d-flex">
                <div class="bloc-edit">
                    <h2>Informations générale</h2>
                    <div class="user-edit">
                        <mat-form-field appearance="outline" style="width: 100%;">
                            <mat-label>Nom de l'agence</mat-label>
                            <input matInput type="text" placeholder="Nom" [(ngModel)]="currentAgency.Name" />
                        </mat-form-field>

                        <mat-form-field appearance="outline" style="width: 100%;">
                            <mat-label>Ref</mat-label>
                            <input matInput type="text" placeholder="Ref" [(ngModel)]="currentAgency.Ref" />
                        </mat-form-field>

                        <mat-form-field appearance="outline" style="width: 100%;">
                            <mat-label>Type de transport</mat-label>
                            <mat-select [(ngModel)]="currentAgency.TransportType">
                                <mat-option *ngFor="let transport of TransportType" [value]="transport.value">{{
                                    transport.label }}</mat-option>
                            </mat-select>
                        </mat-form-field>

                        <p> <b>Logo :</b> </p>
                        <div class="d-flex upload-bloc">
                            <button (click)="fileInput.click()" style="width: 100%;height: 50px;" color="accent"
                                type="button" mat-flat-button>
                                Charger un fichier
                                <mat-icon fontSet="material-symbols-rounded">
                                    file_upload
                                </mat-icon>
                            </button>
                            <div *ngIf="currentAgency.LogoPath && currentAgency.LogoName; else noPreview" class="d-flex"
                                style="flex-direction: column;">
                                <img *ngIf="currentAgency.LogoPath" [src]="'https://'+currentAgency.LogoPath"
                                    height="60px" width="60px" alt="preview">
                                <div style="padding-top: 13px;width: 50%;text-align: center;">
                                    {{ currentAgency.LogoName }}
                                </div>
                            </div>
                            <ng-template #noPreview>
                                <div style="padding-top: 15px;">
                                    Aucun fichier chargé.
                                </div>
                            </ng-template>

                        </div>

                        <input hidden (change)="onFileSelected($event)" #fileInput type="file">
                    </div>

                </div>
            </div>
        </mat-tab>
        <mat-tab label="Créneau">
            <div class="bloc-content d-flex">
                <div class="bloc-edit">
                    <div style="text-align: right;">
                        <button class="noShadow" color="primary" mat-mini-fab (click)="editModeClick('frequences')"
                            [disabled]="editModes.frequences && !isCurrentFrequenceComplete()">
                            <mat-icon fontSet="material-symbols-rounded">
                                {{ editModes.frequences ? "done" : "add" }}
                            </mat-icon>
                        </button>
                    </div>

                    <ng-container *ngIf="currentAgency">
                        <ng-container *ngIf="editModes.frequences">
                            <ng-container *ngTemplateOutlet="blocEditFrequency;context{ agency : currentAgency }">
                            </ng-container>
                        </ng-container>
                        <ng-container *ngIf="!editModes.frequences">
                            <ng-container *ngTemplateOutlet="blocDisplayFrequency;context{ agency : currentAgency }">
                            </ng-container>
                        </ng-container>
                    </ng-container>
                </div>
            </div>

        </mat-tab>
        <mat-tab label="Parc Auto">
            <div class="bloc-content d-flex">

                <div class="bloc-edit">
                    <h2>Liste des auto</h2>
                    <div class="auto-list">
                        <ng-container *ngIf="currentAgency?.Vehicles?.length; else noAuto">
                            <div class="d-flex" style="gap: 10px;" *ngFor="let item of currentAgency?.Vehicles">
                                <div>
                                    <mat-form-field appearance="outline">
                                        <mat-label>Matricule</mat-label>
                                        <input matInput placeholder="Matricule" [(ngModel)]="item.Matricule">
                                    </mat-form-field>
                                </div>

                                <div>
                                    <mat-form-field appearance="outline">
                                        <mat-label>Nb. Place</mat-label>
                                        <input matInput placeholder="Nb. Place" [(ngModel)]="item.NbPlace">
                                    </mat-form-field>
                                </div>
                            </div>
                        </ng-container>

                        <ng-template #noAuto>
                            <div>
                                Vous n'avez ajouté encore aucun automobile.
                            </div>
                        </ng-template>
                    </div>


                    <div>
                        <button mat-flat-button color="primary" (click)="onAddAuto()">Ajouter un auto</button>
                    </div>

                </div>


            </div>
        </mat-tab>
        <mat-tab label="Employée">
            <div class="bloc-content d-flex">
                <div class="bloc-edit large">
                    <div style="text-align: right;">
                        <button class="noShadow" color="primary" mat-mini-fab (click)="editModeClick('employee')"
                            [disabled]="editModes.employee && !isCurrentEmployeeComplete()">
                            <mat-icon fontSet="material-symbols-rounded">
                                {{ editModes.employee ? "done" : "person_add" }}
                            </mat-icon>
                        </button>
                    </div>

                    <h2>Gestion des employées</h2>
                    <div class="auto-list">
                        <ng-container *ngIf="editModes.employee">
                            <ng-container *ngTemplateOutlet="blocEditEmployee;">
                            </ng-container>

                        </ng-container>
                        <ng-container *ngIf="!editModes.employee">
                            <ng-container *ngIf="currentAgency.Employees?.length; else noEmployee">
                                <ng-container
                                    *ngTemplateOutlet="blocDisplayEmployee; context{ employees : currentAgency.Employees }">
                                </ng-container>
                            </ng-container>

                            <ng-template #noEmployee>
                                Aucun utilisateur dans cet agence.
                            </ng-template>
                        </ng-container>
                    </div>

                </div>
            </div>

        </mat-tab>
    </mat-tab-group>

    <hr>
    <ng-container *ngTemplateOutlet="blocDisplayAgencies; context : { agenciesList : getValidateAgencies() } ">
    </ng-container>

</app-main-drawer>

<ng-template #blocDisplayEmployee let-employees="employees">
    <ng-container *ngIf="employees?.length; else noEmployees">
        <table class="custom-table" mat-table [dataSource]="employees">
            <ng-container matColumnDef="LastName">
                <th mat-header-cell *matHeaderCellDef> Nom(s)</th>
                <td mat-cell *matCellDef="let element">{{ element.LastName }}</td>
            </ng-container>

            <ng-container matColumnDef="FirstName">
                <th mat-header-cell *matHeaderCellDef> Prénom(s)</th>
                <td mat-cell *matCellDef="let element">{{ element.FirstName }}</td>
            </ng-container>

            <ng-container matColumnDef="Email">
                <th mat-header-cell *matHeaderCellDef> Email</th>
                <td mat-cell *matCellDef="let element">{{ element.Email }}</td>
            </ng-container>

            <ng-container matColumnDef="Role">
                <th mat-header-cell *matHeaderCellDef> Rôle</th>
                <td mat-cell *matCellDef="let element">{{ getRoleList(element.UserRoles)}}</td>
            </ng-container>

            <ng-container matColumnDef="Statut">
                <th mat-header-cell *matHeaderCellDef> Statut</th>
                <td mat-cell *matCellDef="let element">{{ element.IsActive ? "actif" : "inactif" }}</td>
            </ng-container>

            <ng-container matColumnDef="Action">
                <th mat-header-cell *matHeaderCellDef> Actions</th>
                <td mat-cell *matCellDef="let element">
                    <button mat-icon-button (click)="editUser(element)" matTooltip="editer">
                        <mat-icon fontSet="material-symbols-rounded">
                            edit
                        </mat-icon>
                    </button>

                    <button mat-icon-button *ngIf="element.ID" matTooltip="archiver">
                        <mat-icon fontSet="material-symbols-rounded">
                            archive
                        </mat-icon>
                    </button>

                    <button mat-icon-button matTooltip="supprimer">
                        <mat-icon fontSet="material-symbols-rounded">
                            delete
                        </mat-icon>
                    </button>


                </td>
            </ng-container>

            <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
            <tr mat-row *matRowDef="let row; columns: displayedColumns;"></tr>
        </table>

    </ng-container>
    <ng-template #noEmployees>
        Vous n'avez aucun employée enregistrés pour le moment.
    </ng-template>
</ng-template>

<ng-template #blocEditEmployee>
    <div class="user-edit">
        <mat-form-field appearance="outline" style="width: 100%;">
            <mat-label>Nom(s)</mat-label>
            <input matInput type="text" placeholder="nom(s) de l'employée" [(ngModel)]="currentEditEmployee.LastName" />
        </mat-form-field>

        <mat-form-field appearance="outline" style="width: 100%;">
            <mat-label>Prénom(s)</mat-label>
            <input matInput type="text" placeholder="prénom(s) de l'employée"
                [(ngModel)]="currentEditEmployee.FirstName" />
        </mat-form-field>

        <mat-form-field appearance="outline" style="width: 100%;">
            <mat-label>adresse email</mat-label>
            <input matInput type="email" placeholder="adresse email de l'employée"
                [(ngModel)]="currentEditEmployee.Email" />
        </mat-form-field>

        <ng-container *ngIf="currentEditEmployee.ID">

            <mat-form-field appearance="outline" style="width: 100%;">
                <mat-label>mot de passe</mat-label>
                <input matInput [type]="passwordType" placeholder="mot de passe"
                    [(ngModel)]="currentEditEmployee.Password" />
                <mat-icon fontSet="material-symbols-rounded" matSuffix (click)="showHidePassword()"
                    style="cursor: pointer;">{{ passwordType == "text" ? 'visibility' :
                    'visibility_off' }}
                </mat-icon>
            </mat-form-field>

            <!-- <mat-form-field appearance="outline" style="width: 100%;">
                <mat-label>confirmation du mot de passe</mat-label>
                <input matInput [type]="passwordType" placeholder="confirmation du mot de passe"
                    [(ngModel)]="confirmPassword" />
            </mat-form-field> -->

        </ng-container>

        <mat-form-field appearance="outline" style="width: 100%;">
            <mat-label>Rôle</mat-label>
            <mat-select [(ngModel)]="currentEditEmployee.UserRoles" [compareWith]="compareUserRoles" multiple>
                <mat-option *ngFor="let role of roleListWrapper" [value]="role">{{ role.Role.RoleName }}</mat-option>
            </mat-select>
        </mat-form-field>
        <p *ngIf="!currentEditEmployee.ID">
            Lorsque vous cliquerez sur l'icone valider, l'utilisateur recevra un mail qui l'invitera à choisir un mot de
            passe
            afin qu'il puisse se connecter.
        </p>

    </div>
</ng-template>

<ng-template #blocEditFrequency let-agency="agency">
    <div>
        <div class="d-flex" style="gap: 50px;" *ngIf="currentFrequence">
            <div>
                <div>
                    <mat-form-field appearance="outline">
                        <mat-label>Nom de la période</mat-label>
                        <input matInput type="text" [(ngModel)]="currentFrequence.Name" />
                    </mat-form-field>
                </div>
                <div>
                    <mat-form-field appearance="outline">
                        <mat-label>Choisir la periode indiquée</mat-label>
                        <mat-date-range-input [rangePicker]="picker">
                            <input matStartDate placeholder="Start date" [(ngModel)]="currentFrequence.StartDate">
                            <input matEndDate placeholder="End date" [(ngModel)]="currentFrequence.EndDate">
                        </mat-date-range-input>
                        <mat-hint>DD/MM/YYYY – DD/MM/YYYY</mat-hint>
                        <mat-datepicker-toggle matSuffix [for]="picker"></mat-datepicker-toggle>
                        <mat-date-range-picker touchUi #picker></mat-date-range-picker>
                    </mat-form-field>
                </div>


            </div>
            <div style="display: flex;flex-direction:column;gap: 20px;">
                <mat-slide-toggle [(ngModel)]="selectAllModel" (ngModelChange)="selectOrUnselectAll()">
                    Tout selectionner/déselectionner.</mat-slide-toggle>

                <mat-slide-toggle [(ngModel)]="currentFrequence.Lun">Lundi</mat-slide-toggle>

                <mat-slide-toggle [(ngModel)]="currentFrequence.Mar">Mardi</mat-slide-toggle>

                <mat-slide-toggle [(ngModel)]="currentFrequence.Mer">Mercredi</mat-slide-toggle>

                <mat-slide-toggle [(ngModel)]="currentFrequence.Jeu">Jeudi</mat-slide-toggle>

                <mat-slide-toggle [(ngModel)]="currentFrequence.Ven">Vendredi</mat-slide-toggle>

                <mat-slide-toggle [(ngModel)]="currentFrequence.Sam">Samedi</mat-slide-toggle>

                <mat-slide-toggle [(ngModel)]="currentFrequence.Dim">Dimanche</mat-slide-toggle>

            </div>

        </div>
    </div>
    <!-- <div>
        <button mat-flat-button color="primary" (click)="addFrequence()">Ajouter</button>
    </div> -->



</ng-template>

<ng-template #blocDisplayFrequency let-agency="agency">
    <h2>Liste des créneaux</h2>

    <ng-container *ngIf="agency.Frequences?.length; else noFrequence;">

        <table>
            <tr>
                <th>Nom</th>
                <th class="w-max">Période</th>
                <th class="w-max">Périodicité</th>
                <th class="w-max">Actions</th>
            </tr>
            <ng-container *ngIf="agency.Frequences?.length">
                <tr *ngFor="let item of agency.Frequences">
                    <td> {{ item.Name }} </td>
                    <td>
                        {{ item.StartDate | date:'dd/MM/yyyy' }} - {{ item.EndDate | date:'dd/MM/yyyy' }}
                    </td>
                    <td style="padding:0 10px;">
                        <ng-container *ngIf="item.Lun"> Lun,
                        </ng-container>
                        <ng-container *ngIf="item.Mar"> Mar,
                        </ng-container>
                        <ng-container *ngIf="item.Mer"> Mer,
                        </ng-container>
                        <ng-container *ngIf="item.Jeu"> Jeu,
                        </ng-container>
                        <ng-container *ngIf="item.Ven"> Ven,
                        </ng-container>
                        <ng-container *ngIf="item.Sam"> Sam,
                        </ng-container>
                        <ng-container *ngIf="item.Dim"> Dim
                        </ng-container>

                    </td>
                    <td>
                        <div class="d-flex" style="justify-content: center;">
                            <button mat-icon-button (click)="editFrequence(item)" [disabled]="true">
                                <mat-icon fontSet="material-symbols-rounded">
                                    edit
                                </mat-icon>
                            </button>

                            <button mat-icon-button (click)="removeFrequence(item)">
                                <mat-icon fontSet="material-symbols-rounded">
                                    delete
                                </mat-icon>
                            </button>
                        </div>
                    </td>
                </tr>
            </ng-container>

        </table>
    </ng-container>
    <ng-template #noFrequence>
        <p>Vous n'avez aucune fréquence.</p>
        <button mat-flat-button (click)="editModeClick('frequences')">Ajouter une Fréquence</button>
    </ng-template>

</ng-template>

<ng-template #blocDisplayAgencies let-agenciesList="agenciesList">
    <ng-container *ngIf="agenciesList?.length;">
        <table class="custom-table spacing" style="border:1px solid;margin-bottom: 20px;" mat-table
            [dataSource]="agenciesList">
            <ng-container matColumnDef="Name">
                <th mat-header-cell *matHeaderCellDef> Nom de l'agence</th>
                <td mat-cell *matCellDef="let element">{{ element.Name }}</td>
            </ng-container>

            <ng-container matColumnDef="Ref">
                <th mat-header-cell *matHeaderCellDef> Ref</th>
                <td mat-cell *matCellDef="let element">{{ element.Ref }}</td>
            </ng-container>

            <ng-container matColumnDef="TransportType">
                <th mat-header-cell *matHeaderCellDef> TransportType</th>
                <td mat-cell *matCellDef="let element">{{ getTransportType(element.TransportType) }}</td>
            </ng-container>

            <ng-container matColumnDef="Logo">
                <th mat-header-cell *matHeaderCellDef> Logo</th>
                <td mat-cell *matCellDef="let element">
                    <img [src]="'https://'+element.LogoPath" alt="thumbnail" height="50" width="50" />
                </td>
            </ng-container>

            <ng-container matColumnDef="Action">
                <th mat-header-cell *matHeaderCellDef> Actions</th>
                <td mat-cell *matCellDef="let element">
                    <button mat-icon-button (click)="onEditAgency(element)" matTooltip="editer">
                        <mat-icon fontSet="material-symbols-rounded">
                            edit
                        </mat-icon>
                    </button>

                    <button mat-icon-button *ngIf="element.ID" matTooltip="archiver">
                        <mat-icon fontSet="material-symbols-rounded">
                            archive
                        </mat-icon>
                    </button>

                    <button mat-icon-button matTooltip="supprimer">
                        <mat-icon fontSet="material-symbols-rounded">
                            delete
                        </mat-icon>
                    </button>


                </td>
            </ng-container>

            <tr mat-header-row *matHeaderRowDef="displayedColumnsAgencies"></tr>
            <tr mat-row *matRowDef="let row; columns: displayedColumnsAgencies;"></tr>
        </table>
    </ng-container>

</ng-template>